#include <stdio.h>
#include <signal.h>
#include <unistd.h>

struct Comp {
  void (*handler) (void*, int);
  void* buf;
  int   siz;
};

struct Comp comp[1000];
int compHead = 0;
int compTail = 0;

void doAsync (void (*aHandler)(void*, int), void* aBuf, int aSiz) {
  comp[compHead].handler = aHandler;
  comp[compHead].buf     = aBuf;
  comp[compHead].siz     = aSiz;
  compHead = (compHead + 1) % (sizeof (comp) / sizeof (struct Comp));
}

void interruptServiceRoutine () {
  struct Comp c;
  if (compHead != compTail) {
    c = comp[compTail];
    c.handler (c.buf, c.siz);
    compTail = (compTail + 1) % (sizeof (comp) / sizeof (struct Comp));
  }
}

void printString (void* buf, int siz) {
  printf ("%s\n", (char*) buf); fflush (stdout);
}

void boot () {
  sigset (SIGALRM, interruptServiceRoutine);
  ualarm (999999, 999999);
}

int main (int argc, char** argv) {
  boot ();
  printf ("Scheduling some things to do asynchronously\n"); fflush (stdout);
  doAsync (printString, "Thing 1", 0);
  doAsync (printString, "Thing 2", 0);
  doAsync (printString, "Thing 3", 0);
  printf ("Now waiting for them to complete.\n"); fflush (stdout);
  while(1)
    sleep(1000);
}
